if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
}
-setup() {
- git config core.worktree "$GIT_WORK_TREE"
- git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
- git config vcsh.vcsh 'true'
- touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
- git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+fatal() {
+ echo "$SELF: fatal: $1" >&2
+ exit $2
}
-init() {
- verbose "init() begin"
- [ -e "$GIT_DIR" ] &&
- echo "$SELF: fatal: $GIT_DIR exists" &&
- return 10
- export GIT_WORK_TREE="$HOME"
- mkdir -p "$GIT_WORK_TREE"
- cd "$GIT_WORK_TREE" ||
- { echo "$SELF: fatal: could not enter $GIT_WORK_TREE"; return 11; }
- cd "$GIT_WORK_TREE"
- git init
- setup
- verbose "init() end"
+error() {
+ echo "$SELF: error: $1" >&2
}
-use() {
- verbose "use() begin"
- if [ ! -d "$GIT_DIR" ]; then
- echo E: no repository found for "$VCSH_REPO_NAME" >&2
- return 12
- fi
- export GIT_DIR
- export GIT_WORK_TREE="$(git config --get core.worktree)"
- export VCSH_DIRECTORY="$VCSH_REPO_NAME"
- verbose "use() end"
+info() {
+ echo "$SELF: info: $1"
}
-
-if [ "$1" = 'clone' ]; then
- export VCSH_COMMAND="$1"
- GIT_REMOTE="$2"
- export GIT_REMOTE
- VCSH_REPO_NAME="$3"
- [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
- export VCSH_REPO_NAME
- export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'delete' ] ||
- [ "$1" = 'enter' ] ||
- [ "$1" = 'init' ] ||
- [ "$1" = 'run' ] ||
- [ "$1" = 'seed-gitignore' ] ||
- [ "$1" = 'setup' ]; then
- [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && exit 1
- export VCSH_COMMAND="$1"
- export VCSH_REPO_NAME="$2"
- export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
- shift 2
- export VCSH_EXTERNAL_COMMAND="$*"
- if [ "$VCSH_COMMAND" = 'run' ]; then
- [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && exit 1
- fi
-elif [ "$1" = 'help' ] ||
- [ "$1" = 'list' ]; then
- export VCSH_COMMAND="$1"
-else
- [ -z $1 ] && help && exit 0
- export VCSH_COMMAND='run'
- export VCSH_REPO_NAME="$1"
- export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
- [ -d $GIT_DIR ] || { help; exit 1; }
- shift 1
- export VCSH_EXTERNAL_COMMAND="git $*"
-fi
-
-
-for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
-do
- if [ ! -d "$check_directory" ]; then
- if [ -e "$check_directory" ]; then
- echo "$SELF: fatal: $check_directory exists but is not a directory" >&2
- exit 13
- else
- echo "$SELF: info: attempting to create $check_directory"
- mkdir -p "$check_directory" || { echo "$SELF: fatal: could not create $check_directory" >&2; exit 50; }
- fi
- fi
-done
-
-
-if [ "$VCSH_COMMAND" = 'clone' ]; then
- verbose "clone begin"
+clone() {
init
git remote add origin "$GIT_REMOTE"
git config branch.master.remote origin
git fetch
for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
[ -e "$object" ] &&
- echo "$SELF: error: $object exists." &&
+ error "'$object' exists." &&
VCSH_CONFLICT=1;
done
[ "$VCSH_CONFLICT" = '1' ] &&
- echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
- echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
- exit 17
+ fatal "will stop after fetching and not try to merge!
+ Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
git merge origin/master
- verbose "clone end"
-
-#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
-elif [ "$VCSH_COMMAND" = 'help' ]; then
- help
+}
-elif [ "$VCSH_COMMAND" = 'delete' ]; then
- verbose "delete begin"
+delete() {
old_dir="$PWD"
cd "$HOME"
- use || exit $?
- echo "$SELF: info: This operation WILL DETROY DATA!"
+ use
+ info "This operation WILL DETROY DATA!"
files=$(git ls-files)
echo "These files will be deleted:
read answer
[ "x$answer" = "xYes, do as I say" ] || exit 16
for file in $files; do
- rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
+ rm -f $file || info "could not delete '$file', continuing with deletion"
done
- rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
+ rm -rf "$GIT_DIR" || info "could not delete '$GIT_DIR'"
cd "$old_dir"
- verbose "delete end"
+}
-elif [ "$VCSH_COMMAND" = 'enter' ]; then
- verbose "enter begin"
- use || exit $?
+enter() {
+ use
$SHELL
- verbose "enter end"
+}
-elif [ "$VCSH_COMMAND" = 'init' ]; then
- verbose "init begin"
- init
- verbose "init end"
+init() {
+ [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
+ export GIT_WORK_TREE="$HOME"
+ mkdir -p "$GIT_WORK_TREE"
+ cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+ cd "$GIT_WORK_TREE"
+ git init
+ setup
+}
-elif [ "$VCSH_COMMAND" = 'list' ]; then
- verbose "list begin"
+list() {
for i in "$VCSH_BASE"/*.git; do
echo $(basename "$i" .git)
done
- verbose "list end"
+}
-elif [ "$VCSH_COMMAND" = 'run' ]; then
- verbose "run begin"
- use || exit $?
+run() {
+ use
$VCSH_EXTERNAL_COMMAND
- verbose "run end"
+}
-elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
- verbose "seed-gitignore begin"
- use || exit $?
+seed_gitignore() {
+ use
# Switching directory as this has to be executed from $HOME to be of any use.
# Going back into old directory at the end in case `vcsh use` is reactivated.
old_dir="$PWD"
file="$new"
done;
done | sort -u)
- tempfile=$(mktemp) ||
- { echo "$SELF: fatal: could not create tempfile"; exit 51; }
+ tempfile=$(mktemp) || fatal "could not create tempfile" 51
echo '*' > "$tempfile"
for gitignore in $gitignores; do
echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
rm -f "$tempfile" &&
exit
if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
- echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
+ info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
- { echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"; exit 53; }
+ fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
fi
mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
- { echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && exit 53; }
+ fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
cd "$old_dir"
- verbose "seed-gitignore end"
+}
-elif [ "$VCSH_COMMAND" = 'setup' ]; then
- verbose "seed-gitignore begin"
- use || exit $?
- setup || exit $?
- verbose "seed-gitignore end"
+setup() {
+ use
+ git config core.worktree "$GIT_WORK_TREE"
+ git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+ git config vcsh.vcsh 'true'
+ touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+ git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+}
-else
- verbose "defaulting to calling help()"
- help
- echo "$SELF: fatal: You should never reach this code. File a bug, please."
- exit 99
+use() {
+ if [ ! -d "$GIT_DIR" ]; then
+ fatal "no repository found for '$VCSH_REPO_NAME'" 12
+ fi
+ export GIT_WORK_TREE="$(git config --get core.worktree)"
+ export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+if [ "$1" = 'clone' ]; then
+ [ -z $2 ] && fatal "$1: please specify a remote" 1
+ export VCSH_COMMAND="$1"
+ GIT_REMOTE="$2"
+ [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+ export VCSH_REPO_NAME
+ export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+ [ "$1" = 'enter' ] ||
+ [ "$1" = 'init' ] ||
+ [ "$1" = 'run' ] ||
+ [ "$1" = 'seed-gitignore' ] ||
+ [ "$1" = 'setup' ]; then
+ [ -z $2 ] && fatal "$1: please specify repository to work on" 1
+ [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
+ export VCSH_COMMAND="$1"
+ export VCSH_REPO_NAME="$2"
+ export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+ [ "$1" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$@"
+ [ "$1" = 'seed-gitignore' ] && export VCSH_COMMAND=seed_gitignore
+elif [ "$1" = 'list' ]; then
+ export VCSH_COMMAND="$1"
+elif [ -n "$1" ]; then
+ export VCSH_COMMAND=run
+ export VCSH_REPO_NAME="$1"
+ export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+ [ -d $GIT_DIR ] || { help; exit 1; }
+ shift 1
+ export VCSH_EXTERNAL_COMMAND="git $*"
+else
+ # $1 is empty, or 'help'
+ help && exit
fi
+
+for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+do
+ if [ ! -d "$check_directory" ]; then
+ if [ -e "$check_directory" ]; then
+ fatal "'$check_directory' exists but is not a directory" 13
+ else
+ info "attempting to create '$check_directory'"
+ mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+ fi
+ fi
+done
+
+verbose "$VCSH_COMMAND begin"
+$VCSH_COMMAND
+verbose "$VCSH_COMMAND end, exiting"